//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <ipl.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

IplImage *nuevofondo= cvLoadImage("naranjos.jpg");
bool acabar= false;

//---------------------------------------------------------------------------

void MaxCanales (IplImage *color, IplImage *gris)
// Dada una imagen con 3 canales, devuelve otra imagen con 1 canal
// donde el valor de cada pxel es el mximo de los 3 canales de entrada
{
  IplImage *can1= cvCreateImage(cvGetSize(gris), IPL_DEPTH_8U, 1);
  IplImage *can2= cvCreateImage(cvGetSize(gris), IPL_DEPTH_8U, 1);
  cvSplit(color, gris, can1, can2, NULL);
  cvMax(can1, can2, can1);
  cvMax(can1, gris, gris);
  cvReleaseImage(&can1);
  cvReleaseImage(&can2);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // 1. Abrir la fuente de vdeo
  CvCapture *cap= NULL;
  acabar= false;
  // 1.1. De cmara
  if (RadioButton1->Checked) {
    cap= cvCaptureFromCAM(-1);
  }
  // 1.2. O de archivo AVI
  else {
    if (OpenDialog1->Execute())
      cap= cvCaptureFromAVI(OpenDialog1->FileName.c_str());
    else
      return;
  }
  if (!cap) {
    if (RadioButton1->Checked)
      ShowMessage("No se puede encontrar ninguna cmara.");
    else
      ShowMessage("El archivo no se encuentra o no es un AVI vlido.");
    return;
  }

  // 2. Abrir el vdeo e inicializar el modelo y las otras imgenes
  IplImage *img= cvQueryFrame(cap);
  if (!img) {
    ShowMessage("El capturador de vdeo no se ha creado correctamente.");
    cvReleaseCapture(&cap);
    return;
  }
  IplImage *cop= cvCloneImage(img);     // Frame de entrada rectificado
  cop->origin= 0;
  IplImage *modelo= cvCloneImage(cop);  // Modelo de fondo (frame inicial)
  if (img->origin)
    cvFlip(modelo);
  modelo->origin= 0;
  IplImage *tmp= cvCloneImage(cop);     // Escalar el modelo de fondo
  cvResize(nuevofondo, tmp);
  cvReleaseImage(&nuevofondo);
  nuevofondo= tmp;
  IplImage *dif= cvCloneImage(cop);     // Imgenes de diferencia y mscara
  IplImage *masc= cvCreateImage(cvGetSize(cop), cop->depth, 1);
  int numf= 0;                          // Nmero de frames aadidas al modelo

  // 3. Para cada frame, hasta que se acabe el vdeo o se pulse acabar
  int tecla= 0;
  while (img && !acabar && tecla!=27 && tecla!='q') {
    tecla= tolower(cvWaitKey(1));
    // 3.1. Copiar la imagen en top-left
    if (img->origin==0)
      cvCopy(img, cop);
    else
      cvFlip(img, cop);
    cvNamedWindow("Entrada", 0);
    cvShowImage("Entrada", cop);
    Application->ProcessMessages();
    // 3.2. Si se pulsa la tecla 'a', se aade la imagen al modelo de fondo
    if (tecla=='a') {
      numf++;
      if (numf==1)
        cvCopy(cop, modelo);
      else {
        cvAddWeighted(modelo, (numf-1.0)/numf, cop, 1.0/numf, 0, modelo);
      }
      cvSaveImage("pic2.png", cop);
      cvNamedWindow("Modelo", 0);
      cvShowImage("Modelo", modelo);
    }
    if (tecla=='d')
      cvSetCaptureProperty(cap, CV_CAP_PROP_SOURCE, 0);
    // 3.3. Calcular la diferencia de la imagen al modelo
    cvAbsDiff(modelo, cop, dif);
    MaxCanales(dif, masc);
    cvNamedWindow("Diferencia", 0);
    cvShowImage("Diferencia", masc);
    // 3.4. Binarizar la diferencia para obtener la mscara
    cvThreshold(masc, masc, TrackBar1->Position, 255, CV_THRESH_BINARY);
    cvNot(masc, masc);
    // 3.5. Aplicar el nuevo fondo al resultado
    cvCopy(nuevofondo, cop, masc);
    cvNamedWindow("Salida", 0);
    cvShowImage("Salida", cop);
    img= cvQueryFrame(cap);
  }

  // 4. Acabar liberando memoria
  cvReleaseCapture(&cap);
  cvReleaseImage(&cop);
  cvReleaseImage(&modelo);
  cvReleaseImage(&dif);
}
//---------------------------------------------------------------------------
 
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  acabar= true;      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  acabar= true;      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  if (!nuevofondo) {
    nuevofondo= cvCreateImage(cvSize(100,100), IPL_DEPTH_8U, 3);
    cvSet(nuevofondo, CV_RGB(255,0,0));
  }
}
//---------------------------------------------------------------------------

